OsmoGSMTester - Bug #3881

ofono: Sometimes provides wrong net interface in DBus API
04/01/2019 09:54 AM - pespin

Status: Resolved Start date: 04/01/2019
Assignee: pespin % Done: 100%
Category:

Target version:

Spec Reference:

Description
| saw some osmo-gsm-tester tests that failed:

04:15:11.807003 run osmo-hlr_ 10.42.42.2: Add subscriber {algo=1l, algo_str='compl28vl'
, imsi='901700000010978', msisdn='1820"', subscriber_id=1}

04:15:12.839312 bus /gobi_10: Setting Online False

04:15:13.857703 bus /gobi_10: Setting Powered False

04:15:20.353010 bus /gobi_10: Setting Powered True

04:15:21.545365 bus /gobi_10: Setting Online True

04:15:23.631041 tst /gobi_10: Connect to ('901', '70")

04:15:23.665366 tst /gobi_10: Manufacturer: 'Quectel', Model: 'EC20', Revi
sion: 'EC20EQARO2A13E2G 1 [Jul 5 2017 10:49:17]', Serial: '20120822'

04:15:23.666671 tst ping_idle_ping.py:47: waiting for modems to attach...
04:15:30.904372 tst /gobi_10: Registering with operator /gobi_10/operator/
90170 ('901', '70")

04:15:36.831376 tst ping_idle_ping.py:51: waiting for modems to attach to data service
S...

04:15:44.260744 tst /gobi_10: context activated {apn='inet46',6 path='/gobi

_10/context2', properties={AccessPointName='inet46', Active=True, AuthenticationMethod='chap', IPv
6.Settings={}, Name='Internet', Password='', Protocol='ip', Settings={Address='176.16.46.1"', Domai
nNameServers=['192.168.100.1', '8.8.8.8'], Gateway='176.16.46.2"', Interface='wwan0', Method='stati
c', Netmask='255.255.255.252"}, Type='internet', Username='ogt'}, user='ogt'}

04:15:44.262922 tst ping_idle_ping.py:56: Setting up data plane for "'/gobi_10/context
2'"
04:15:44.415972 run ifup (pid=7019) : Launched
04:15:45.421749 run ifup (pid=7019): ERR: Terminated: ERROR {rc=1} [trial-1810=g
prs:oc2g+mod-bts0-dynts-osmo=/gobi_10=ifup (pid=7019) ]
04:15:45.423708 run ifup (pid=7019): stderr:
| (launched: 2019-04-01_04:15:44.404070)
| Cannot find device "wwanO"
04:15:45.427225 tst ping_idle_ping.py:57: ERR: Error: Exited in error 1 [trial-1810=g
prs:oc2g+mod-btsO-dynts-osmo=ping_idle_ping.py:57]
04:15:45.433608 tst ping_idle_ping.py:57: Test FAILED (70.0 sec)

So I went and checked configuration of the net namespaces (no interesting netiface in main netns):

root@osmo—-gsm-tester-prod:~# for ns in “ip netns’; do echo "== $ns =="; ip netns exec $ns ip 1; do
ne
== 1-5.3.2 ==
1: lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group default glen 1
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
18: wwanl: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode DEFAULT group default glen 10

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff
== 1-5.3.3 ==
1: lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group default glen 1
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
19: wwan2: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode DEFAULT group default glen 10

link/ether 7a:3e:ed:a5:84:9a brd ff:ff:ff:ff:ff:ff

== 1-5.3.5 ==
1: lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group default glen 1
According to ./show_usb_device.py, 1-5.4.1.5 containing wwan0 is the only Gobi2000 modem in the setup, but ofono states in the

link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
wwan3: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff

1-5.3.6 ==

lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00

wwand: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab:84:9a brd ff:ff:ff:ff:ff:ff

1-5.4.1.2 ==
lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00

wwan6: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff
wwan7: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff

1-5.4.1.3 ==

lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00

wwan8: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff
wwan9: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff

1-5.4.1.5 ==

lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00

wwan0O: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode

link/ether 7a:3e:ed:ab:84:9a brd ff:ff:ff:ff:ff:ff

1-5.4.1.6 ==
lo: <LOOPBACK> mtu 65536 gdisc noop state DOWN mode DEFAULT group
link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00

DEFAULT group default

default glen 1

DEFAULT group default

default glen 1

DEFAULT group default

DEFAULT group default

default glen 1

DEFAULT group default

DEFAULT group default

default glen 1

DEFAULT group default

default glen 1

glen

glen

glen

glen

glen

glen

glen

10

10

10

10

10

10

10

43: dev2343: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode DEFAULT group default gle

1000
link/ether 7a:3e:ed:a5:84:9a brd ff:ff:ff:ff:ff:ff

test that it is using an EC20 modem (as expected, since it's the only in resources.conf to be used on gprs tests).

The first EC20 modem in resources.conf.prod (the one which should be used and thus is used) is the one in 1-5.4.1.6, which

interestingly has a "dev2343" net iface instead of usual "wwanX" one. That may be related regarding how ofono decided to provide

"wwan0" for it instead of "dev2343".

Running "modem-netns-setup.py stop" to return all net ifaces to main netns, then running ./show_usb_device.py shows how net
ifaces relate to each modem:

root@osmo-gsm-tester—-prod:~# ./show_usb_device.py

{<DEVICE ID 05c¢6:9215 on Bus 001 Address 041>: {'cdc': ['cdc-wdm5'],
'name': 'Quectel Quectel LTE '
'Module',
'net': ['dev2343'],
'path': '/sys/bus/usb/devices/1-5.4.1.6/",
'serial': ['ttyUSB26',
'ttyUSB24"',
"ttyUSB27"',
"ttyUSB25']},
<DEVICE ID 05c6:9205 on Bus 001 Address 031>: {'cdc': ['cdc-wdmO'],
'name': 'Qualcomm Incorporated '
'Qualcomm Gobi 2000"',
'net': ['wwanO'],
'path': '/sys/bus/usb/devices/1-5.4.1.5/",
<DEVICE ID 1199:68c0 on Bus

<DEVICE ID 1199:68c0 on Bus

<DEVICE ID 05c6:9215 on Bus

<DEVICE ID 05c6:9215 on Bus

<DEVICE ID 05c6:9215 on Bus

<DEVICE ID 05c6:9215 on Bus

<DEVICE ID 10c4:ea60 on Bus

<DEVICE ID 0403:6001 on Bus
001 Address 038>:

001 Address 037>:

001 Address 036>:

001 Address 035>:

001 Address 034>:

001 Address 033>:

001 Address 008>:

001 Address 006>:

'serial': ['ttyUSB7',
"ttyUSB5',

"ttyUSB6']},

{'cde': ['cdc-wdm9', 'cdc-wdm8'],
'name': 'Sierra Wireless, '
'Incorporated MC7304"',
'net': ['wwan9', 'wwan8'],
'path': '/sys/bus/usb/devices/1-5.4.1.3/"',
'serial': ['ttyUSB32',
'ttyUSB31',
"ttyUSB33']},
{'cdec': ['cdc-wdm7', 'cdc-wdmo6'],
'name': 'Sierra Wireless, '
'Incorporated MC7304"',
'net': ['wwan7', 'wwan6'],
'path': '/sys/bus/usb/devices/1-5.4.1.2/"',
'serial': ['ttyUSB29',
'ttyUSB28"',
"ttyUSB30']},
{'cdc': ['cdc-wdm4d'],
'name': 'Quectel Quectel LTE '
'Module’',
'net': ['wwand'],
'path': '/sys/bus/usb/devices/1-5.3.6/",
'serial': ['ttyUSB23',
'ttyUSB21',
'ttyUSB22"',
'ttyUSB20']},
{'cdec': ['cdc-wdm3'],
'name': 'Quectel Quectel LTE '
'Module',
'net': ['wwan3'],
'path': '/sys/bus/usb/devices/1-5.3.5/",
'serial': ['ttyUSB18',
'ttyUSB16',
'ttyUSB19',
'ttyUSB17'1},
{'cdec': ['cdc-wdm2'],
'name': 'Quectel Quectel LTE '
'Module',
'net': ['wwan2'],
'path': '/sys/bus/usb/devices/1-5.3.3/"',
'serial': ['ttyUSB15',
'ttyUSB13',
"ttyUSB14',
"ttyUSB12']},
{'cdc': ['cdc-wdml'],
'name': 'Quectel Quectel LTE '
'Module',
'net': ['wwanl'],
'path': '/sys/bus/usb/devices/1-5.3.2/",
'serial': ['ttyUSB11l',
"ttyUSBI',
"ttyUSB10',
"ttyUSB8']},
{'cde': [1,
'name': 'Silicon Labs CP2104 '
'USB to UART Bridge '
'Controller’,
'net': [],
'path': '/sys/bus/usb/devices/1-5.2/"',
'serial': ['ttyUSB4']l},
{'cdec': [1,
'name': 'FTDI FT232R USB UART',
'net': [],
'path': '/sys/bus/usb/devices/1-5.1/"',
'serial': ['ttyUSB1l']},
<DEVICE ID 0403:6001 on Bus 001 Address 007>: {'cdc': T[],

'name': 'FTDI FT232R USB UART',
'net': [],
'path': '/sys/bus/usb/devices/1-1.4/",
'serial': ['ttyUSB2']},
<DEVICE ID 0403:6001 on Bus 001 Address 005>: {'cdc': [1,
'name': 'FTDI FT232R USB UART',
'net': [1,
'path': '/sys/bus/usb/devices/1-1.3/"',
'serial': ['ttyUSBO']},
<DEVICE ID 10c4:ea60 on Bus 001 Address 004>: {'cdc': T[],
'name': 'Silicon Labs CP2102

'USB to UART Bridge

'Controller’',
'net': [1,

'path': '/sys/bus/usb/devices/1-1.1/",

'serial': ['ttyUSB3']}}

So definetly ofono is announcing wwan0 for 1-5.4.1.6 instead of dev2343. Could it be related to our patch to avoid dropping

information about the modem netns in ofono (to allow moving net ifaces to other netns):

https://git.sysmocom.de/ofono/commit/?h=0smo-gsm-tester&id=e77b82a1bd1986aab42a119e0556¢5941795992¢

Related issues:

Related to OsmoGSMTester - Support #3931: Contact quectel to get info about m... New

04/15/2019

History

#1 - 04/01/2019 10:20 AM - pespin

Interestingly, according to dmesg wwan0 iface was first assigned to Gobi2000 (1-5.4.1.5) and later to EC20 (1-5.4.1.6):

root@osmo—-gsm-tester-prod:~# dmesg | grep wwanO

[ 17.028189] gmi_wwan 1-5.4.1.5:1.0 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.5,

7a:3e:ed:ab5:84:9a
[ 4121.598616] gmi_wwan 1-5.
[ 4126.115197] gmi_wwan 1-5.
7a:3e:ed:ab5:84:9a

NN
I
oo
A

[29263.362075] gmi_wwan 1-5.4.1.6:1.4 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.6,

Ta:3e:ed:ab5:84:9a

.0 wwan0O: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.5,
.0 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.5,

WWAN/QMI device,

WWAN/QMI device
WWAN/QMI device,

WWAN/QMI device,

WWAN/QMI device

WWAN/QMI device

[216205.198406] gmi_wwan 1-5.4.1.6:1.4 wwanO: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6,

[216215.028310] gmi_wwan 1-5.4.1.6:1.4 wwan0O: register 'qmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
, Ta:3e:ed:ab5:84:9a

[314476.953665] gmi_wwan 1-5.4.1.6:1.4 wwanO: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6,

[314487.046418] gmi_wwan 1-5.4.1.6:1.4 wwan0O: register 'gqmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device

, Ta:3e:ed:ab5:84:9a

Even more interesting, it seems it was registered twice without unregistering in the middle, and once for each modem:

[ 4126.115197] gmi_wwan 1-5.4.1.5:1.0 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.5,

Ta:3e:ed:ab5:84:9a

[29263.362075] gmi_wwan 1-5.4.1.6:1.4 wwanO: register 'qmi_wwan' at usb-0000:00:12.2-5.4.1.6,

Ta:3e:ed:a5:84:9a

And actually now there exists wwan0 and dev2342:

WWAN/QMI device,

WWAN/QMI device,

16: wwanO: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode DEFAULT group default glen 1000

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff

2343: dev2343: <BROADCAST,MULTICAST> mtu 1500 gdisc noop state DOWN mode DEFAULT group default glen 1000

link/ether 7a:3e:ed:ab5:84:9a brd ff:ff:ff:ff:ff:ff

Here's full log of dmesg filtered for both modems:

root@osmo-gsm-tester-prod:~# dmesg | grep -e 1-5.4.1.5 -e 1-5.4.1.6

[ 12.612269] usb 1-5.4.1.5: new high-speed USB device number 17 using ehci-pci

[ 12.722635] usb 1-5.4.1.5: config 1 has an invalid interface number: 1 but max is 0
[ 12.722648] usb 1-5.4.1.5: config 1 has no interface number 0

[ 12.724575] usb 1-5.4.1.5: New USB device found, idVendor=05c6, idProduct=9204

[ 12.724583] usb 1-5.4.1.5: New USB device strings: Mfr=3, Product=2, SerialNumber=0
https://git.sysmocom.de/ofono/commit/?h=osmo-gsm-tester&id=e77b82a1bd1986aab42a119e0556c5941795992e
119903]
635413]
6358701

640530]
880569]
990495]
990506]
usb 1-5.4.1.5:
usb 1-5.4.1.5:
gcserial 1-5.4.
usb 1-5.4.1.5:
usb 1-5.4.1.5:
gcserial 1-5.4.

usb
usb
usb
usb
usb

1-5.

17
1-
=

1=5,

[SBNC,INE;)

B s D

(SN, BNC, BN, B E ]

gcserial 1-5.4.
usb 1-5.4.1.5:
gcserial 1-5.4.
usb 1-5.4.1.5:
gcserial 1-5.4.
usb 1-5.4.1.5:
gmi_wwan 1-5.4.

gmi_wwan 1-5.4.
ed:ab5:84:9a

usb
usb
usb
usb
usb

1-5.

B D D D

e e

od o

o Oy O OO O

gcserial 1-5.4.
usb 1-5.4.1.6:
gcserial 1-5.4.
usb 1-5.4.1.6:
gcserial 1-5.4.
usb 1-5.4.1.6:
gcserial 1-5.4.
usb 1-5.4.1.6:
agmi_wwan 1-5.4.
ami_wwan 1-5.4.
ed:a5:84:9a
usb 1-5.4.1.5:

ami_wwan 1-

gcserial 1-

gcserial 1-
gcserial 1-
1-5.

usb
usb
usb
usb
usb
usb
usb

1-5.

B S S =

N N e

5
5
S
5

odc

(GG, NG, BN, BN C, BN R C)

4.
4.
4.
4.

gcserial 1-5.4.
usb 1-5.4.1.5:
usb 1-5.4.1.5:
gcserial 1-5.4.

usb
usb
usb
usb
usb

gmi_

1-5.
1-5.

=
17

1-5.

5o
5

B b D D

e e

odbe

wwan 1-5.
ami_wwan 1-5.4.
ed:a5:84:9a

(GG, BNC, BN G BN ]

gcserial 1-5.4.
usb 1-5.4.1.5:
gcserial 1-5.4.
usb 1-5.4.1.5:
gcserial 1-5.4.
usb 1-5.4.1.5:
usb 1-5.4.1.6:

gcserial
gcserial
gcserial
gcserial
qmi_wwan
usb 1-5.
usb 1-5.
usb 1-5.

4
4
4

od o

B b D D

Product: Qualcomm Gobi 2000

Manufacturer: Qualcomm Incorporated

1.5:1.1: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSBS

USB disconnect, device number 17

1.5:1.1: device disconnected

new high-speed USB device number 18 using ehci-pci

New USB device found, idVendor=05c6, idProduct=9205

New USB device strings: Mfr=3, Product=2, SerialNumber=0
Product: Qualcomm Gobi 2000

Manufacturer: Qualcomm Incorporated

1.5:1.1: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB5S
1.5:1.2: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB6
1.5:1.3: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB7
1.5:1.0: cdc-wdmO: USB WDM device

1.5:1.0 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.5, WWAN/QMI device,

new high-speed USB device number 23 using ehci-pci

New USB device found, idVendor=05c6, idProduct=9215

New USB device strings: Mfr=1, Product=2, SerialNumber=0
Product: Quectel LTE Module

Manufacturer: Quectel

1.6:1.0: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB24
1.6:1.1: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB25
1.6:1.2: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB26
1.6:1.3: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSB27
1.6:1.4: cdc-wdmb5: USB WDM device

1.6:1.4 wwan5: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device,

USB disconnect, device number 18

1.5:1.0 wwanO: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.5, WWAN/QMI device
1.5:1.1: device disconnected
1.5:1.2: device disconnected
1.5:1.3: device disconnected

new high-speed USB device number 28 using ehci-pci
config 1 has an invalid interface number: 1 but max is 0
config 1 has no interface number 0

New USB device found, idVendor=05c6, idProduct=9204

New USB device strings: Mfr=3, Product=2, SerialNumber=0
Product: Qualcomm Gobi 2000

Manufacturer: Qualcomm Incorporated

1.5:1.1: Qualcomm USB modem converter detected

Qualcomm USB modem converter now attached to ttyUSBS

USB disconnect, device number 28

1.5:1.1: device disconnected

new high-speed USB device number 31 using ehci-pci

New USB device found, idVendor=05c6, idProduct=9205

New USB device strings: Mfr=3, Product=2, SerialNumber=0
Product: Qualcomm Gobi 2000

Manufacturer: Qualcomm Incorporated

1.5:1.0: cdc-wdmO: USB WDM device

1.5:1.0 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.5, WWAN/QMI device,

1.5:1.1: Qualcomm USB modem converter detected
Qualcomm USB modem converter now attached to ttyUSBS
1.5:1.2: Qualcomm USB modem converter detected
Qualcomm USB modem converter now attached to ttyUSB6
1.5:1.3: Qualcomm USB modem converter detected
Qualcomm USB modem converter now attached to ttyUSB7
USB disconnect, device number 23

1.6:1.0: device disconnected
1.6:1.1: device disconnected
1.6:1.2: device disconnected
1.6:1.3: device disconnected
1.6:1.4 wwan5: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6, WWAN/QMI device

new high-speed USB device number 32 using ehci-pci
New USB device found, idVendor=05c6, idProduct=9215
New USB device strings: Mfr=1, Product=2, SerialNumber=0
4130.990512] usb 1-5.4.1.6: Product: Quectel LTE Module

4130.990517] usb 1-5.4.1.6: Manufacturer: Quectel

4131.010294] gcserial 1-5.4.1.6:1.0: Qualcomm USB modem converter detected
4131.010833] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB24
4131.014332] gcserial 1-5.4.1.6:1.1: Qualcomm USB modem converter detected
4131.014804] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB25
4131.020926] gcserial 1-5.4.1.6:1.2: Qualcomm USB modem converter detected
4131.021384] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB26
4131.022133] gcserial 1-5.4.1.6:1.3: Qualcomm USB modem converter detected
4131.022452] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB27
4131.023803] gmi_wwan 1-5.4.1.6:1.4: cdc-wdm5: USB WDM device

4131.024474] gmi_wwan 1-5.4.1.6:1.4 wwan5: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device,
7a:3e:ed:ab5:84:9a

[29253.269410] usb 1-5.4.1.6: USB disconnect, device number 32

[29253.270225] gcserial 1-5.4.1.6:1.0: device disconnected

[29253.273356] gcserial 1-5.4.1.6:1.1: device disconnected

[29253.274099] gcserial 1-5.4.1.6:1.2: device disconnected

[29253.274689] gcserial 1-5.4.1.6:1.3: device disconnected

[29253.284031] gmi_wwan 1-5.4.1.6:1.4 wwan5: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
[29263.219314] usb 1-5.4.1.6: new high-speed USB device number 39 using ehci-pci

[29263.329609] usb 1-5.4.1.6: New USB device found, idVendor=05c6, idProduct=9215

[29263.329619] usb 1-5.4.1.6: New USB device strings: Mfr=1, Product=2, SerialNumber=0

[29263.329625] usb 1-5.4.1.6: Product: Quectel LTE Module

[29263.329630] usb 1-5.4.1.6: Manufacturer: Quectel

[29263.347866] gcserial 1-5.4.1.6:1.0: Qualcomm USB modem converter detected
[29263.348302] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB24
[29263.352125] gcserial 1-5.4.1.6:1.1: Qualcomm USB modem converter detected
[29263.352602] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB25
[29263.359027] gcserial 1-5.4.1.6:1.2: Qualcomm USB modem converter detected
[29263.359538] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB26
[29263.360253] gcserial 1-5.4.1.6:1.3: Qualcomm USB modem converter detected
[29263.360567] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB27
[29263.361434] gmi_wwan 1-5.4.1.6:1.4: cdc-wdm5: USB WDM device

[29263.362075] gmi_wwan 1-5.4.1.6:1.4 wwanO: register 'gmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device,
Ta:3e:ed:a5:84:9a

[216205.188995] usb 1-5.4.1.6: USB disconnect, device number 39

[216205.189841] gcserial 1-5.4.1.6:1.0: device disconnected

[216205.190687] gcserial 1-5.4.1.6:1.1: device disconnected

[216205.191495] gcserial 1-5.4.1.6:1.2: device disconnected

[216205.192310] gcserial 1-5.4.1.6:1.3: device disconnected

[216205.198406] gmi_wwan 1-5.4.1.6:1.4 wwan0O: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
[216214.884456] usb 1-5.4.1.6: new high-speed USB device number 40 using ehci-pci

[216214.993613] usb 1-5.4.1.6: New USB device found, idVendor=05c6, idProduct=9215

[216214.993625] usb 1-5.4.1.6: New USB device strings: Mfr=1, Product=2, SerialNumber=0

[216214.993630] usb 1-5.4.1.6: Product: Quectel LTE Module

[216214.993635] usb 1-5.4.1.6: Manufacturer: Quectel

[216215.011726] gcserial 1-5.4.1.6:1.0: Qualcomm USB modem converter detected
[216215.012182] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB24
[216215.016500] gcserial 1-5.4.1.6:1.1: Qualcomm USB modem converter detected
[216215.016992] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB25
[216215.023360] gcserial 1-5.4.1.6:1.2: Qualcomm USB modem converter detected
[216215.025394] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB26
[216215.026280] gcserial 1-5.4.1.6:1.3: Qualcomm USB modem converter detected
[216215.026637] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB27
[216215.027590] gmi_wwan 1-5.4.1.6:1.4: cdc-wdmb5: USB WDM device

[216215.028310] gmi_wwan 1-5.4.1.6:1.4 wwan0O: register 'gqmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
, Ta:3e:ed:ab5:84:9a

[314476.941924] usb 1-5.4.1.6: USB disconnect, device number 40

[314476.942968] gcserial 1-5.4.1.6:1.0: device disconnected

[314476.944105] gcserial 1-5.4.1.6:1.1: device disconnected

[314476.944983] gcserial 1-5.4.1.6:1.2: device disconnected

[314476.946091] gcserial 1-5.4.1.6:1.3: device disconnected

[314476.953665] gmi_wwan 1-5.4.1.6:1.4 wwan0O: unregister 'gmi_wwan' usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
[314486.892590] usb 1-5.4.1.6: new high-speed USB device number 41 using ehci-pci

[314487.006696] usb 1-5.4.1.6: New USB device found, idVendor=05c6, idProduct=9215

[314487.006707] usb 1-5.4.1.6: New USB device strings: Mfr=1, Product=2, SerialNumber=0

[314487.006712] usb 1-5.4.1.6: Product: Quectel LTE Module

[314487.006717] usb 1-5.4.1.6: Manufacturer: Quectel

[314487.037244] gcserial 1-5.4.1.6:1.0: Qualcomm USB modem converter detected
[314487.038110] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB24
[314487.039345] gcserial 1-5.4.1.6:1.1: Qualcomm USB modem converter detected
[314487.039959] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB25
[314487.041322] gcserial 1-5.4.1.6:1.2: Qualcomm USB modem converter detected
[314487.041966] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB26
[314487.043429] gcserial 1-5.4.1.6:1.3: Qualcomm USB modem converter detected
[314487.043999] usb 1-5.4.1.6: Qualcomm USB modem converter now attached to ttyUSB27

[314487.045720] gmi_wwan 1-5.4.1.6:1.4: cdc-wdm5: USB WDM device

[314487.046418] gmi_wwan 1-5.4.1.6:1.4 wwan0O: register 'gqmi_wwan' at usb-0000:00:12.2-5.4.1.6, WWAN/QMI device
, Ta:3e:ed:ab:84:9%a

So it can clearly be seen that:

- During initial boot, gobi2000 is assigned wwan0 and ec20 is assigned wwan5.

- Both of them crash from time to time (devices are unregistered and then registered again).

- At some point (29263.362075), while gobi2000 is registered, then EC20 crashes and when registering again, it gets assigned wwan0 despite it
should be for gobi2000?! (dev2343 doesn't show up in dmesg)

So my guess is that in 29263.362075 when ec20 crashed, it was assigned wwan0 because gobi2000's wwan0 was not in the main netns. Then |
possibly spotted the crash and moved it to its netns again (./netns-modem-setup.py start), probably at some point returning all of them to the main

netns and thus creating some kind of collision (2 ifaces named wwan0) and the kernel renaming one of them, and ofono not catching the rename.

What I'd investigate: See how this naming-collision is handled in the kernel between netns, and how udev announced them, then see if ofono
implements a catch for this renaming.

#2 - 04/01/2019 10:38 AM - pespin

| confirm ofono doesn't handle iface name renaming. | tried changing the name of one iface manually with following command, and ofono didn't output
any information:

ip link set wwan9 name wwan9pespin

That's what "udev monitor" shows while calling the command to move wwan9-old -> wwan9-new:

KERNEL[598426.927211] move /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/wwan9-new (net)
UDEV  [598426.959213] move /devices/pci0000:00/0000:00:12.2/usbl1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1

0/net/wwan9 (net)

#3 - 04/01/2019 10:56 AM - pespin

| did test manually what happened to prove the concept (renaming to existing name in default netns inside another iface, then move it back to default):

$ ip link set wwan9-old netns tmp

KERNEL[598537.320874] remove /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/wwan9-old (net)

UDEV  [598537.332401] remove /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/wwan9 (net)

$ ip netns exec tmp ip link set wwan9-old name wwan8
(nothing shown in udev monitor since it's in a different netns)
$ ip netns delete tmp

KERNEL[598659.888878] add /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/wwan8 (net)
KERNEL[598659.889040] move /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/dev25 (net)
UDEV  [598660.058499] add /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1
0/net/wwan8 (net)
UDEV [598660.070552] move /devices/pci0000:00/0000:00:12.2/usb1/1-5/1-5.4/1-5.4.1/1-5.4.1.3/1-5.4.1.3:1.1

0/net/dev25 (net)

And indeed ofono didn't notice the change (I don't see related output in its stdout/stderr).

#4 - 04/01/2019 04:28 PM - pespin

I'm working on an ofono patch to update the interface send over DBus upon iface rename, but | think | am hitting this systemd-udev bug:
https://github.com/systemd/systemd/issues/9426

#5 - 04/01/2019 06:41 PM - pespin
- Status changed from New to In Progress

- % Done changed from 0 to 30

| confirm | see the systemd bug in debian9 (up-to-date systems), "udevadm monitor -p" is quite useful for that.
| submitted 2 patches to ofono Mailing lists which allows ofono to track network interface renames (if udev works without bugs).
So given we have the bug, | see several paths here:

e Add udev rules to rename modem network interfaces to always have the same name, this way even if a modem crashes it will keep the same
name and ofono will submit the correct name.

e Our own ofono has a patch to avoid dropping the net device (and the whole modem) once it detects the net device gets out. If my patches are
accepted, we need to change this patch to flag the net device in order to be able to drop it when the iface reappears in default netns after
modem crash, otherwise after detecting the "move" the new device name is added but the old one is not dropped, so we end up with 2 devices
and then the old one can override the new one when setting NetworkInterface propery.

e Contact quectel and try to get rid of modem crashes. See if we can upgrade the firmware (ask for downgrade path possibility).

#6 - 04/02/2019 06:19 AM - laforge
On Mon, Apr 01, 2019 at 06:41:49PM +0000, pespin [REDMINE] wrote:
- Contact quectel and try to get rid of modem crashes. See if we can upgrade the firmware (ask for downgrade path possibility).
While | think it's useful to investigate updates for all kinds of
reasons, | don't think you will ever be able to make the assumption that

the baseband stack won't crash, particularly in our type of usage. And
| would say that for any type of baseband/vendor.

#7 - 04/02/2019 04:20 PM - pespin
- % Done changed from 30 to 50
pespin wrote:
e Add udev rules to rename modem network interfaces to always have the same name, this way even if a modem crashes it will keep the
same name and ofono will submit the correct name.
It took a big effort, but finally was able to make it work. dhcpcd was racing against udev and bringing interfaces up before udev tried renaming, which
failed because iface was already up.
So, on top of the udev rule, one needs to configure dhcpcd to prevent it from managing those net ifaces you want to rename through udev. In
/etc/dhcped.conf append:
# Don't ifup on modem ifaces, it prevents renaming
denyinterfaces ww*
Then the udev rule /etc/udev/rules.d/70-net-setup-link-modems.rules:
SUBSYSTEM!="net", GOTO="net_setup_link_end"

ACTION!="add", GOTO="net_setup_link_end"

IMPORT {builtin}="net_id"
ENV{DEVTYPE}=="wwan", ENV{ID_NET_NAME_PATH}!="", NAME="S$env{ID_NET_NAME_PATH}"

LABEL="net_setup_link_end"

For some reason, SierraW modems don't get property ID_NET_NAME_PATH during call to "net_id" builtin, and so rule to rename the device doesn't
apply, but we don't care since anyway we don't use gprs on those devices during testing.

#8 - 04/02/2019 05:47 PM - pespin

In Prod system none of the modems gets ID_NET_NAME_PATH. The reason is the same as per SierraW ones in RnD: It's devpath is too long/deep
(too many usb-hub levels on it). That makes the resulting ID_NET_NAME_PATH > IFNAMESIZ (15 chars) which prevents it from setting
ID_NET_NAME_PATH.

This scenario is actually documented in systemd source code: https:/github.com/systemd/systemd/blob/master/src/udev/udev-builtin-net_id.c#L43

So we need to either:

e Drop one usb-hub level in the quadmomem usb path, so it fits in 15 chars for ec20 modems
e Adding an explicit UDEV rule matching a specific devpath and providing a manual name for each modem

#9 - 04/02/2019 07:14 PM - pespin
- % Done changed from 50 to 60

| finally went for a 3rd option: if path is too long and ID_NET_NAME_PATH is not set, we generate a unique iface name ourselves by hashing the
devpath of the net iface (prepending character "r").

https://gerrit.osmocom.org/#/c/osmo-ci/+/13495 ansible: osmo-gsm-tester: Make modem net ifaces persistent
TODO:

e follow-up on ofono submitted patches

¢ Contact quectel to get info about updates

¢ Make sure osmo-gsm-tester moved iface to its correct interface during test, in case a previous test made the modem crash (and its iface is
re-registered on the default netns).

#10 - 04/04/2019 02:54 PM - pespin
- % Done changed from 60 to 70

¢ | submitted a patch with a fix for the udev rule which was generating variadic hashes on some scenarios:
https://gerrit.osmocom.org/#/c/osmo-ci/+/13518 ansible: gsm-tester: Remove net iface name from hash input
e osmo-gsm-tester now makes sure the iface is moved to correct netns before using it: https:/gerrit.osmocom.org/#/c/osmo-gsm-tester/+/13526/

TODO:
* merge patches

¢ follow-up on ofono submitted patches (I think not really needed by us anymore since we have persistent interface names)
e Contact quectel to get info about updates (let's see if we can get modems crashing less).

#11 - 04/15/2019 01:41 PM - pespin
- Related to Support #3931: Contact quectel to get info about modem updates (hopefully less crashes) added

#12 - 04/15/2019 01:41 PM - pespin
- Status changed from In Progress to Resolved

- % Done changed from 70 to 100

Handling quectel contac tto upgrade firmware in #3931, we can close this ticket.
